
/***************
 * Base States *
 ***************/
.background {
  background-color: $background;
  color: $text;
}

dnd {
  color: on($background);
}

.normal-icons {
  -gtk-icon-size: 16px;
}

.large-icons {
  -gtk-icon-size: 32px;
}

.lowres-icon:not(.large-icons) {
  -gtk-icon-size: 16px;
}

.symbolic-circular {
  background-color: $fill;
  border-radius: $circular-radius;
  padding: 0;
  min-height: 32px;
  min-width: 32px;
}

spinner:disabled,
arrow:disabled,
scrollbar:disabled,
check:disabled,
radio:disabled,
treeview.expander:disabled { -gtk-icon-filter: opacity(0.5); }

%view, .view {
  background-color: $base;
  color: $text;

  // &:selected:hover { box-shadow: inset 0 0 0 9999px rgba($primary, 0.08); }

  &:disabled { color: $text-disabled; }

  &:selected {
    @extend %selected_items_color;
  }
}

textview {
  // FIXME: we need to override background-color to ensure text rendering

  text {
    background-color: $base;
    selection { &:focus, & { @extend %selected_items_primary; }}
  }

  border {
    background-color: $base-alt;
    color: $text-secondary; // FIXME: not working
  }
}

iconview {
  @extend %view;
  &:hover, &:selected { border-radius: $corner-radius / 2; }
}

rubberband {
  border: 1px solid $primary;
  background-color: rgba($primary, 0.3);
}

flowbox {
  > rubberband { @extend rubberband; }

  > flowboxchild {
    padding: 4px;
    border-radius: $corner-radius;

    &:selected { @extend %selected_items_color; }

    button.remove-button.osd {
      min-height: $small-size;
      min-width: $small-size;
      padding: $space-size;
    }
  }
}

.content-view .tile {
  &:selected {
    background-color: transparent;
  }
}

gridview {
  > rubberband { @extend rubberband; }

  > child {
    padding: 3px;

    &:selected {
      outline-color: $overlay-selected;

      @extend %selected_items;
    }

    box { //cells
      border-spacing: 8px; //label separation
      margin: 12px;
    }
  }
}

coverflow cover {
  color: $text;
  background-color: $base;
  border: 1px solid black;
}

label {
  &.separator {
    color: $text-secondary;
  }

  > selection { @extend %selected_items_primary; }

  &:disabled {
    opacity: 1;
    filter: none;
    color: $text-disabled;

    // selection { color: $text-disabled; }

    headerbar &,
    tab &,
    button & { color: inherit; }
  }

  &.osd {
    border-radius: $corner-radius;
    background-color: $tooltip;
    color: on($tooltip);
  }
}

%dim-label, .dim-label { color: $text-secondary; }

.accent {
  color: $primary;
}

.success {
  color: $success;
}

.warning {
  color: $warning;
}

.error {
  color: $error;
}

window.assistant {
  .sidebar {
    padding: 4px 0;
  }

  .sidebar label {
    min-height: $medium-size;
    padding: 0 12px;
    color: $text-disabled;
    font-weight: 500;

    &.highlight { color: $text; }
  }
}

%osd {
  color: on($base);
  background-color: $base;
  background-clip: padding-box;
  border-radius: $corner-radius;
  border: none;
}

.osd {
  @extend %osd;
  padding: $space-size;
  margin: $space-size;
  box-shadow: $shadow-z6;

  &.circular { border-radius: $circular-radius; }
}


/*********************
 * Spinner Animation *
 *********************/
@keyframes spin {
  to { transform: rotate(1turn); }
}

spinner {
  background: none;
  opacity: 0; // non spinning spinner makes no sense
  -gtk-icon-source: -gtk-icontheme('process-working-symbolic');

  &:checked {
    opacity: 1;
    animation: spin 1s linear infinite;

    &:disabled { opacity: 0.5; }
  }
}

// General Typography
.large-title {
  font-weight: 300;
  font-size: 24pt;
}

.title {
  &-1 {
    font-weight: 800;
    font-size: 20pt;
  }

  &-2 {
     font-weight: 800;
     font-size: 15pt;
  }

  &-3 {
    font-weight: 700;
    font-size: 15pt;
  }

  &-4 {
    font-weight: 700;
    font-size: 13pt;
  }
}

.heading {
  font-weight: 700;
  font-size: 11pt;
}

.body {
  font-weight: 400;
  font-size: 11pt;
}

.caption {
  font-weight: 400;
  font-size: 9pt;

  &-heading {
    font-weight: 700;
    font-size: 9pt;
  }
}

/****************
 * Text Entries *
 ****************/
%entry,
entry {
  %entry_basic, & {
    min-height: $medium-size;
    padding: 0 8px;
    border-spacing: $space-size;
    border-radius: $corner-radius;
    caret-color: currentColor; // this shouldn't be needed.

    @include entry(normal);

    &:focus-within { @include entry(checked); }

    &:drop(active) { @include entry(hover); }

    &:disabled { @include entry(disabled); }

    // &.search { border-radius: $circular-radius; }

    &.flat {
      min-height: 0;
      padding: 2px;
      border-radius: 0;
      background-color: transparent;
    }

    image { // icons inside the entry
      color: $text-secondary;

      &:hover, &:active { color: $text; }

      &:disabled { color: $text-disabled; }

      &.left {
        margin-left: ($medium-size - 16px) / 2 - 8px;
        margin-right: 6px;
      }

      &.right {
        margin-left: 6px;
        margin-right: ($medium-size - 16px) / 2 - 8px;
      }
    }

    undershoot {
      &.left { @include undershoot(left); }

      &.right { @include undershoot(right); }
    }

    > text > selection { @extend %selected_items_primary; }

    // entry error and warning style
    @each $e_type, $e_color in (error, $error),
                               (success, $success),
                               (warning, $warning) {
      &.#{$e_type} {
        @include entry(normal, $e_color);

        image { color: $e_color; }

        selection {
          color: on($e_color);
          background-color: $e_color;
        }

        &:focus-within { @include entry(checked, $e_color); }

        &:disabled { @include entry(disabled, $e_color); }
      }
    }
  }

  > progress,
  progress > trough > progress {
    margin: 2px -8px;
    border-bottom: 2px solid $primary;
    background-color: transparent;
  }

   // linked entries
  .linked:not(.vertical) > & { @extend %linked; }

  // Vertically linked entries
  .linked.vertical > & { @extend %linked-vertical; }
}

%entry_raised {
  border-radius: $corner-radius;

  @include entry(raised-normal);

  &:focus-within { @include entry(raised-focus); }

  &:drop(active) { @include entry(raised-hover); }

  &:disabled { @include entry(raised-disabled); }

  // entry error and warning style
  @each $e_type, $e_color in (error, $error),
                             (warning, $warning) {
    &.#{$e_type} {
      @include entry(raised-normal, $e_color);

      &:focus-within { @include entry(raised-focus, $e_color); }

      &:disabled { @include entry(raised-disabled, $e_color); }

      image {
        color: on($e_color, secondary);

        &:hover, &:active { color: on($e_color); }

        &:disabled { color: on($e_color, disabled); }
      }
    }
  }
}

treeview entry {
  &.flat, & {
    background-color: $base;

    &, &:focus-within {
      border-image: none;
      box-shadow: none;
    }
  }
}

.entry-tag {
  margin: 2px;
  border-radius: $circular-radius;
  box-shadow: none;
  background-color: $track-disabled;
  color: $text;

  &:hover { background-image: image($overlay-hover); }

  // side margins: compensate the entry padding with a negative margin
  // then the negative margin itself
  :dir(ltr) & {
    margin-left: 4px;
    margin-right: 0;
    padding-left: 12px;
    padding-right: 8px;
  }

  :dir(rtl) & {
    margin-left: 0;
    margin-right: 4px;
    padding-left: 8px;
    padding-right: 12px;
  }

  // seems any sizing doesn't work
  &.button {
    box-shadow: none;
    background-color: transparent;

    &:not(:hover):not(:active) { color: $text-secondary; }
  }
}

// Editable Labels
editablelabel > stack > text {
  @include entry(normal);
}

/***********
 * Buttons *
 ***********/
// stuff for .needs-attention
@keyframes needs-attention {
  from { background-image: radial-gradient(farthest-side, $primary 0%, transparentize($primary, 1) 0%); }
  to { background-image: radial-gradient(farthest-side, $primary 95%, transparentize($primary, 1)); }
}

%button-on-dark {
  color: on(dark, secondary);

  &:focus, &:hover, &:active, &:checked { color: on(dark); }
  &:disabled { color: on(dark, secondary-disabled); }
  &:checked:disabled { color: on(dark, disabled); }
}

%button-basic {
  @include button(normal);

  &:focus { @include button(focus); }

  &:hover { @include button(hover); }

  &:active { @include button(active); }

  &:disabled { @include button(disabled); }

  &:checked { @include button(checked); }

  &:checked:hover { @include button(checked-hover); }

  &:checked:disabled { @include button(checked-disabled); }
}

button {
  min-height: 24px;
  min-width: 16px;
  padding: ($medium-size - 24px) / 2 ($medium-size - 16px) / 2;
  border-radius: $corner-radius;
  font-weight: 500;
  @extend %button-basic;

  &:drop(active) { @include button(hover); }

  @at-root %button-flat, &.flat {
    @at-root %button-flat-simple, & {
      @include button(flat-normal);

      &:focus { @include button(flat-focus); }

      &:hover { @include button(flat-hover); }

      &:active { @include button(flat-active); }

      &:disabled { @include button(flat-disabled); }
    }

    &:checked, &:checked:hover { @include button(flat-checked); }

    &:checked:disabled { @include button(flat-checked-disabled); }
  }

  &.text-button {
    min-width: 64px - 16px * 2;
    padding-left: 16px;
    padding-right: 16px;

    &.flat {
      min-width: 64px - 8px * 2;
      padding-left: 8px;
      padding-right: 8px;
    }
  }

  &.image-button {
    min-width: 24px;
    padding: ($medium-size - 24px) / 2;

    @extend %circular-button;
  }

  // NOTE: Some image-only buttons use this as well
  &.text-button.image-button {
    min-width: 24px;
    padding: ($medium-size - 24px) / 2;
    border-radius: $corner-radius;

    label {
      &:first-child { margin-left: 16px - ($medium-size - 24px) / 2; }

      &:last-child { margin-right: 16px - ($medium-size - 24px) / 2; }
    }

    &.flat label {
      &:first-child { margin-left: 12px - ($medium-size - 24px) / 2; }

      &:last-child { margin-right: 12px - ($medium-size - 24px) / 2; }
    }

    image:not(:only-child) { margin: 0 (24px - 16px) / 2; }
  }

  .linked:not(.vertical) > &,
  .linked:not(.vertical) > &.image-button {
    @extend %linked;
  }

  .linked.vertical > &,
  .linked.vertical > &.image-button {
    @extend %linked-vertical;
  }

  .linked:not(.vertical) > &.flat,
  .linked.vertical > &.flat {
    &:not(:only-child) { // specificity bump
      border-radius: $corner-radius;

      // &.image-button:not(.text-button) { border-radius: $circular-radius; }
    }

    &:focus { box-shadow: inset 0 0 0 9999px $overlay-focus; }
  }

  .linked:not(.vertical) > menubutton:first-child > & {
    border-radius: $corner-radius 0 0 $corner-radius;
  }

  .linked:not(.vertical) > menubutton:last-child > & {
    border-radius: 0 $corner-radius $corner-radius 0;
  }

  // big standalone buttons like in Documents pager
  &.osd {
    box-shadow: none;
    padding: ($large-size - 24px) / 2 ($large-size - 16px) / 2;
    background-color: $base;
    border: 1px solid $divider;
    background-clip: padding-box;

    &:hover { background-color: mix($text, $base, 10%); }

    &:active { background-color: mix($text, $base, 20%); }

    &.image-button { padding: ($large-size - 24px) / 2; }

    &:disabled { opacity: 0; }
  }

  // Suggested and Destructive Action buttons
  @each $b_type, $b_color in (suggested-action, $suggested),
                             (destructive-action, $destructive) {
    &.#{$b_type} {
      background-color: $b_color;
      color: on($b_color);
      box-shadow: none;

      &:disabled { @include button(disabled); }

      &:hover {
        box-shadow: inset 0 0 0 9999px transparent,
                    0 2px (4px * .6) -1px rgba($b_color, 0.2),
                    0 4px (5px * .6) 0 rgba($b_color, 0.14),
                    0 1px (10px * .6) 0 rgba($b_color, 0.12);
      }

      &:checked { background-color: mix(on($b_color), $b_color, percentage(0.3)); }

      &:checked:hover {
        box-shadow: inset 0 0 0 9999px transparent,
                    0 3px 3px -3px rgba($b_color, 0.3),
                    0 2px 3px -1px rgba($b_color, 0.24),
                    0 2px 5px 0 rgba($b_color, 0.12);
      }

      &:focus { box-shadow: 0 0 0 2px rgba($b_color, 0.35); }

      &.flat {
        background-color: transparent;
        color: $b_color;

        &:disabled { @include button(flat-disabled); }

        &:checked { background-color: rgba($b_color, 0.3); }
      }
    }
  }

  stackswitcher > & {
    // to position the needs attention dot, padding is added to the button
    // child, a label needs just lateral padding while an icon needs vertical
    // padding added too.

    > label {
      margin: 0 -6px;
      padding: 0 6px;
    }

    > image {
      margin: -3px -6px;
      padding: 3px 6px;
    }

    &.needs-attention {
      > label,
      > image { @extend %needs-attention; }

      &:checked {
        > label,
        > image {
          animation: none;
          background-image: none;
        }
      }
    }
  }

  // hide separators
  &.font,
  &.file {
    separator { @extend %hide_separators; }

    > box { border-spacing: $space-size; }
    > box > box > label { font-weight: bold; }
  }

  @at-root %circular-button,
  &.close,
  &.circular { // The Bloody Circul Button
    border-radius: $circular-radius;

    label { padding: 0; }
  }

  @at-root %small-button {
    min-height: $small-size;
    min-width: $small-size;
    padding: 0;
    border-radius: $circular-radius;
  }
}

%needs-attention {
  animation: needs-attention $ripple-fade-in-duration $ease-out forwards;
  background-repeat: no-repeat;
  background-position: right 3px;
  background-size: 6px 6px;

  &:dir(rtl) { background-position: left 3px; }
}

%linked {
  border-radius: 0;

  &:first-child {
    border-top-left-radius: $corner-radius;
    border-bottom-left-radius: $corner-radius;
  }

  &:last-child {
    border-top-right-radius: $corner-radius;
    border-bottom-right-radius: $corner-radius;
  }

  &:only-child {
    border-radius: $corner-radius;
  }
}

%linked-vertical {
  border-radius: 0;

  &:first-child {
    border-top-left-radius: $corner-radius;
    border-top-right-radius: $corner-radius;
  }

  &:last-child {
    border-bottom-left-radius: $corner-radius;
    border-bottom-right-radius: $corner-radius;
  }

  &:only-child {
    border-radius: $corner-radius;
  }
}

button.color {
  min-height: $small-size;
  min-width: $small-size;
  padding: $space-size;

  colorswatch:only-child {
    // &, overlay { border-radius: 0; }
  }
}

%list_button,
list > row button.image-button:not(.flat) {
  background-color: transparent;
  box-shadow: none;
  border: none;
  &:hover { @include button(hover); }
  &:active,
  &:checked { @include button(active); }

  @each $b_type, $b_color in (suggested-action, $suggested),
                             (destructive-action, $destructive) {
    &.#{$b_type} { // allow colored buttons in lists #3643
      background-color: $b_color;
      color: on($b_color);
    }
  }
}

/*********
 * Links *
 *********/
link, %links {
  color: $link;

  &:visited {
    color: $link-visited;
  }
}

button.link {
  &:link {
    &, &:focus, &:hover, &:active { color: $link; }
  }

  &:visited {
    &, &:focus, &:hover, &:active { color: $link-visited; }
  }

  > label { text-decoration-line: underline; }
}

/*****************
 * GtkSpinButton *
 *****************/
spinbutton {
  &:not(.vertical) {
    // in this horizontal configuration, the whole spinbutton
    // behaves as the entry, so we extend the entry styling
    // and nuke the style on the internal entry
    @extend %entry;

    padding: 0;
    border-spacing: 0;

    > text {
      min-width: $large-size - 8px * 2;
      // reset all the other props since the spinbutton node is styled here
      margin: 0;
      padding-left: $space-size * 2;
      border-image: none;
      border-radius: 0;
      box-shadow: none;
      background-color: transparent;
    }

    > button {
      @extend %button-flat-simple;
      @extend %small-button;

      // margin: $space-size;
      border: solid $space-size transparent;

      // Remove unwanted focus indicator
      &:focus:not(:hover):not(:active):not(:disabled) {
        box-shadow: inset 0 0 0 9999px transparent;
        color: $text-secondary;
      }

      &.up:dir(ltr),
      &.down:dir(rtl) { margin-left: -$space-size / 2; }

      &.up:dir(rtl),
      &.down:dir(ltr) { margin-right: -$space-size / 2; }
    }
  }

  // Vertical
  &.vertical {
    @extend %entry;

    padding: 0;

    &:disabled { color: $text-disabled; }

    > text {
      margin: 0;
      border-image: none;
      border-radius: 0;
      box-shadow: none;
      background-color: transparent;

      min-height: $medium-size;
      min-width: $large-size - $space-size;
      padding: 0;
    }

    > button {
      @extend %button-flat-simple;
      @extend %small-button;
      padding: 0;
      border: solid $space-size transparent;

      // Remove unwanted focus indicator
      &:focus:not(:hover):not(:active) {
        box-shadow: inset 0 0 0 9999px transparent;
        color: $text-secondary;
      }

      &.up { margin: 0 $space-size / 2; }

      &.down { margin: 0 $space-size / 2; }
    }
  }

  // Misc
  // treeview &:not(.vertical),
  list > row &:not(.vertical) {
    > button {
      margin: $space-size;

      &.up:dir(ltr),
      &.down:dir(rtl) { margin-left: $space-size / 2; }

      &.up:dir(rtl),
      &.down:dir(ltr) { margin-right: $space-size / 2; }
    }
  }
}


/**************
 * ComboBoxes *
 **************/

dropdown > button > box {
  border-spacing: $space-size;
}

dropdown,
combobox {
  arrow {
    -gtk-icon-source: -gtk-icontheme('pan-down-symbolic');
    min-height: 16px;
    min-width: 16px;
  }

  // align menu labels with the button label
  > popover.menu {
    margin-top: $space-size - 2px;

    > contents {
      padding: $space-size;

      modelbutton {
        padding-left: $space-size * 1.5;
        padding-right: $space-size * 1.5;
      }
    }
  }

  button.combo cellview {
    &:dir(ltr) { margin-left: 8px - ($medium-size - 16px) / 2; }
    &:dir(rtl) { margin-right: 8px - ($medium-size - 16px) / 2; }
  }

  &.linked {
    button:nth-child(2) {
      &:dir(ltr) {
        border-top-left-radius: 0;
        border-bottom-left-radius: 0;
      }
      &:dir(rtl) {
        border-top-right-radius: 0;
        border-bottom-right-radius: 0;
      }
    }
  }

  > .linked:not(.vertical) > entry:not(:only-child) {
    border-radius: $corner-radius;

    &:first-child {
      margin-right: -$medium-size;
      padding-right: $medium-size;
    }

    &:last-child {
      margin-left: -$medium-size;
      padding-left: $medium-size;
    }
  }

  > .linked:not(.vertical) > button:not(:only-child) {
    @extend %button-flat;
    // @extend %small-button;

    min-height: 16px;
    min-width: 16px;
    margin: ($medium-size - $small-size) / 2;
    padding: ($small-size - 16px) / 2;
    border-radius: $corner-radius;
  }
}

// the combo is a composite widget so the way we do button linking doesn't
// work, special case needed. See
// https://bugzilla.gnome.org/show_bug.cgi?id=733979

.linked:not(.vertical) > combobox {
  &:not(:first-child) > box > button.combo {
    border-top-left-radius: 0;
    border-bottom-left-radius: 0;
  }

  &:not(:last-child) > box > button.combo {
    border-top-right-radius: 0;
    border-bottom-right-radius: 0;
  }
}

.linked.vertical > combobox {
  &:not(:first-child) > box > button.combo {
    border-top-left-radius: 0;
    border-top-right-radius: 0;
  }

  &:not(:last-child) > box > button.combo {
    border-bottom-left-radius: 0;
    border-bottom-right-radius: 0;
  }
}

button.combo:only-child {
  border-radius: $corner-radius;
  font-weight: normal;

  @include entry(normal);

  &:focus { @include button(flat-focus); }

  &:hover { @include button(flat-hover); }

  &:active { @include button(flat-active); }

  &:checked { @include button(flat-checked); }

  &:disabled { @include button(disabled); }
}

%toolbar_osd {
  transition: $transition-shadow;
  padding: $space-size;
  border-radius: $corner-radius;
  box-shadow: $shadow-z4, inset 0 1px highlight($surface);
  background-color: $surface;

  &:backdrop { box-shadow: $shadow-z2, inset 0 1px highlight($surface); }
}

/************
 * Toolbars *
 ************/
.toolbar,
toolbar {
  padding: $space-size / 2 $space-size;
  background-color: $background;
  border-spacing: $space-size;

  button { @extend %button-flat; }

  // on OSD
  .osd & { background-color: transparent; }

  // stand-alone OSD toolbars
  &.osd {
    @extend %toolbar_osd;

    &.left,
    &.right,
    &.top,
    &.bottom { border-radius: 0; } // positional classes for `attached` osd toolbars

    &.bottom {
      box-shadow: none;
      background-color: transparent;
      background-image: linear-gradient(to bottom,
                                        transparent,
                                        rgba(black, 0.1) 30%,
                                        rgba(black, 0.2) 50%,
                                        rgba(black, 0.4));
    }
  }

  // toolbar separators
  &.horizontal > separator { margin: 2px; }
  &.vertical > separator { margin: 2px; }

  &:not(.inline-toolbar):not(.osd) {
    scale,
    entry,
    spinbutton,
    button { margin: 2px; }

    .linked entry,
    .linked spinbutton,
    .linked button {
      &:not(:first-child) { margin-left: 0; }
      &:not(:last-child) { margin-right: 0; }
    }

    spinbutton {
      entry,
      button { margin: 0; }
    }

    switch { margin: 2px + $space-size 2px; }
  }
}

// oldstyle toolbar buttons
.toolbar button {
  margin: 1px;
  @extend %button-flat;
  border-radius: $corner-radius / 2;
}

// searchbar
searchbar > revealer > box {
  padding: $space-size;
  border-spacing: $space-size;
  border-style: solid;
  border-width: 0 0 1px;
  border-color: $divider;
  background-color: $background;
  background-clip: border-box;
  box-shadow: none;

  entry { margin: 0; }
}

/***************
 * Header bars *
 ***************/

%titlebar-button {
  @extend %button-flat;
  color: $titlebar-text-secondary;

  .linked:not(.vertical) > & {
    border-radius: $circular-radius;
  }

  &:focus, &:hover, &:active, &:checked { color: $titlebar-text; }

  &:disabled { color: $titlebar-text-secondary-disabled; }

  &:checked {
    &:disabled {
      background-color: transparent;
      color: $titlebar-text-disabled;
    }
  }

  &:backdrop {
    color: $titlebar-text-disabled;

    &:focus, &:hover, &:active { color: $titlebar-text-secondary; }

    &:disabled { color: $titlebar-text-secondary-disabled; }

    &:checked {
      color: $titlebar-text-secondary;

      &:disabled { color: $titlebar-text-secondary-disabled; }
    }
  }
}

%titlebar-entry {
  background-color: $titlebar-fill;
  color: $titlebar-text;

  &:disabled {
    background-color: $titlebar-fill;
    color: $titlebar-text-disabled;
  }

  image {
    color: $titlebar-text-secondary;

    &:hover, &:active { color: $titlebar-text; }

    &:disabled { color: $titlebar-text-disabled; }
  }
}

headerbar {
  transition: background-color $duration $ease-out, color $duration $ease-out;
  box-shadow: inset 0 -1px $divider, inset 0 1px highlight($titlebar);
  background-color: $titlebar;
  color: $titlebar-text;
  min-height: $large-size;
  padding: 0;
  margin: 0;
  border-radius: $window-radius $window-radius 0 0;

  &:disabled { color: $titlebar-text-disabled; }

  &:backdrop {
    background-color: $titlebar-backdrop;
    color: $titlebar-text-secondary;

    &:disabled { color: $titlebar-text-secondary-disabled; }
  }

  .title {
    padding: 0 $space-size * 2;
    font-weight: bold;
  }

  .subtitle {
    padding: 0 $space-size * 2;
    font-size: smaller;
  }

  .subtitle,
  .dim-label {
    transition: color $duration $ease-out;
    color: $titlebar-text-secondary;

    &:backdrop { color: $titlebar-text-disabled; }
  }

  // Don't draw titlebar above titlebar
  headerbar {
    background-color: transparent;
    box-shadow: none;
  }

  splitbutton {
    border-radius: $circular-radius;

    > button,  > menubutton > button {
      min-height: 24px;
      min-width: 24px;
      padding: ($medium-size - 24px) / 2;
      border-radius: $circular-radius;
    }

    > button:dir(ltr),
    > menubutton > button:dir(rtl) {
      border-top-right-radius: $circular-radius;
      border-bottom-right-radius: $circular-radius;
    }

    > button:dir(rtl),
    > menubutton > button:dir(ltr) {
      border-top-left-radius: $circular-radius;
      border-bottom-left-radius: $circular-radius;
    }
  }

  entry { @extend %titlebar-entry; }

  .linked:not(.vertical) > entry:not(:only-child) { border-radius: $corner-radius; }

  button:not(.suggested-action):not(.destructive-action) {
    @extend %titlebar-button;
  }

  button.suggested-action, button.destructive-action {
    &:disabled {
      background-color: $titlebar-fill;
      color: $titlebar-text-disabled;
    }
  }

  button.toggle { border-radius: $circular-radius; }

  popover.background {
    button, entry, spinbutton {
      border-radius: $menuitem-radius;
    }

    button:not(.suggested-action):not(.destructive-action):not(.flat) {
      @extend %button-basic;
    }

    .linked:not(.vertical) > button:not(.suggested-action):not(.destructive-action) {
      border-radius: 0;

      &:first-child { border-radius: $menuitem-radius 0 0 $menuitem-radius; }
      &:last-child { border-radius: 0 $menuitem-radius $menuitem-radius 0; }
      &:only-child { border-radius: $menuitem-radius; }
    }
  }

  stackswitcher { // reset
    margin: $space-size 0;
    border-radius: $circular-radius;

    &.linked:not(.vertical) > button:not(.suggested-action):not(.destructive-action).text-button {
      border-radius: $circular-radius;
    }
  }

  box.vertical & {
    background-color: $titlebar;
  }

  > windowhandle > box {
    padding: 0 $space-size;

    &,
    > box.start,
    > box.end {
      border-spacing: $space-size;
    }
  }

  // add vertical margins to common widget on the headerbar to avoid them spanning the whole height
  entry,
  spinbutton,
  button,
  stackswitcher {
    margin-top: $space-size;
    margin-bottom: $space-size;
  }

  menubutton > button,
  spinbutton > button,
  splitbutton > button {
    margin-top: 0;
    margin-bottom: 0;
  }

  switch {
    margin-top: ($large-size - 24px) / 2;
    margin-bottom: ($large-size - 24px) / 2;
  }

  &.selection-mode {
    // 0.1ms was a workaround for https://gitlab.gnome.org/GNOME/gtk/issues/698
    // but let's keep it for backwards compatibility.
    transition: background-color 0.1ms $ripple-fade-in-duration, color $duration $ease-out;
    box-shadow: inset 0 1px highlight($primary);
    background-color: $primary;
    color: on($primary);

    &:backdrop {
      color: on($primary, secondary);
    }

    .subtitle:link { color: on($primary); }

    button:not(.suggested-action):not(.destructive-action) {
      @extend %button-on-dark;
    }

    .selection-menu {
      padding-left: 16px;
      padding-right: 16px;

      .arrow { -gtk-icon-source: -gtk-icontheme('pan-down-symbolic'); }
    }
  }

  .selection-mode {
    box-shadow: inset 0 1px highlight($primary); // Avoid double shadows
    background-color: $primary;
  }

  // squared corners when the window is maximized, tiled, or fullscreen
  .tiled &,
  .tiled-top &,
  .tiled-right &,
  .tiled-bottom &,
  .tiled-left &,
  .maximized &,
  .fullscreen & {
    border-radius: 0;
  }

  &.default-decoration {
    min-height: $small-size;
    padding: $space-size;
    box-shadow: inset 0 -1px $divider, inset 0 1px highlight($titlebar);

    windowcontrols {
      button,
      menubutton {
        min-height: $small-size;
        min-width: $small-size;
        margin: 0;
        padding: 0;
      }
    }
  }

  .solid-csd & {
    &:dir(rtl), &:dir(ltr) { // specificity bump
      border-radius: 0;
      box-shadow: none; // just remove the highlight
    }
  }
}

window.devel {
  headerbar.titlebar {
    $c: $titlebar;
    $gradient: cross-fade(10% -gtk-icontheme("system-run-symbolic"), image(transparent)) 90% 0/256px 256px no-repeat,
               linear-gradient(to right, transparent 65%, transparentize($primary, 0.8)),
               linear-gradient(to top, darken($c, 3%), $c 3px, lighten($c, 6%));
    @if $variant == 'dark' {
      $gradient: cross-fade(10% -gtk-icontheme("system-run-symbolic"), image(transparent)) 90% 0/256px 256px no-repeat,
                 linear-gradient(to right, transparent 65%, transparentize($primary, 0.9)),
                 linear-gradient(to top, lighten($c, 3%) 3px, lighten($c, 5%));
    }

    background: $titlebar $gradient;

    &:backdrop {
      background: $titlebar cross-fade(10% -gtk-icontheme("system-run-symbolic"), image(transparent)) 90% 0/256px 256px no-repeat,
                  image($titlebar); /* background-color would flash */
    }
  }
}

/************
 * Pathbars *
 ************/
%pathbar_button,
pathbar > button {
  padding-left: ($medium-size - 24px) / 2;
  padding-right: ($medium-size - 24px) / 2;
  border-radius: $corner-radius;
  border-spacing: $space-size / 2;

  label, image {
    margin-left: $space-size / 2;
    margin-right: $space-size / 2;
  }

  label:not(:only-child) {
    &:first-child { margin-left: 0; }
    &:last-child { margin-right: 0; }
  }

  &.text-button {
    min-width: 0;
  }

  &.slider-button {
    padding-left: (24px - 16px) / 2;
    padding-right: (24px - 16px) / 2;
  }
}


/**************
 * Tree Views *
 **************/
columnview.view,
treeview.view {
  border-left-color: $solid-border; // this is actually the tree lines color,
  border-top-color: $solid-border; // while this is the grid lines color, better then nothing

  // FIXME: Avoid transparency background-color being slightly darker
  &:selected {
    background-color: $base;
    background-image: image($overlay-checked);
    box-shadow: none;
  }

  > rubberband { @extend rubberband; } // to avoid borders being overridden by the previously set props

  &:hover, &:selected {
    border-radius: 0;
    box-shadow: none;
  }

  &.separator {
    min-height: 1px + 2px * 2;
    color: $divider;
  }

  // FIXME: box-shadow, background-color and background-image are not available here.
  &:drop(active) {
    box-shadow: none;

    &.after { border-top-style: none; }

    &.before { border-bottom-style: none; }
  }

  > dndtarget:drop(active) {
    border-style: solid none;
    border-width: 1px;
    border-color: $overlay-selected;

    &.after { border-top-style: none; }

    &.before { border-bottom-style: none; }
  }

  &.expander {
    min-width: 16px;
    min-height: 16px;
    color: $text-secondary;
    -gtk-icon-source: -gtk-icontheme('pan-end-symbolic');

    &:dir(rtl) { -gtk-icon-source: -gtk-icontheme('pan-end-symbolic-rtl'); }

    &:checked { -gtk-icon-source: -gtk-icontheme('pan-down-symbolic'); }

    &:hover { color: $text; }

    &:selected {
      color: $primary;

      &:hover { color: rgba($primary, 0.65); }
    }

    &:disabled { color: $text-secondary-disabled; }
  }

  &.progressbar { // progress bar in treeviews
    border-bottom: $bar-size solid $primary;
    box-shadow: none;
    background-color: transparent;
    background-image: none;

    &:selected:hover { box-shadow: none; }
  }

  &.trough { // progress bar trough in treeviews
    border-bottom: $bar-size solid $track-disabled;
    box-shadow: none;
    background-color: transparent;
    background-image: none;

    &:selected:hover { box-shadow: none; }
  }

  > header {
    > button {
      @extend %row_activatable;

      padding: 2px 6px;
      border-style: none solid solid none;
      border-width: 1px;
      border-color: $divider;
      border-radius: 0;
      background-clip: border-box;

      &:not(:focus):not(:hover):not(:active) { color: $text-secondary; }

      &, &:disabled { background-color: $base; }

      &:last-child { border-right-style: none; }

      sort-indicator {
        &.ascending {
          -gtk-icon-source: -gtk-icontheme('pan-up-symbolic');
        }

        &.descending {
          -gtk-icon-source: -gtk-icontheme('pan-down-symbolic');
        }

        min-height: 16px;
        min-width: 16px;
      }
    }
  }

  button.dnd,
  header.button.dnd { // for treeview-like derive widgets
    padding: 2px 6px;
    border-style: none solid solid;
    border-width: 1px;
    border-color: $divider;
    border-radius: 0;
    box-shadow: none;
    background-color: $base;
    background-clip: border-box;
    color: $primary;
  }

  acceleditor > label { background-color: $primary; } // see tests/testaccel to test
}


/*********
 * Menus *
 *********/
menubar {
  padding: 0;
  // box-shadow: inset 0 -1px $divider;
  background-color: $titlebar;
  color: $titlebar-text;

  &:backdrop {
    background-color: $titlebar-backdrop;
    color: $titlebar-text-secondary;
  }

  .csd & { transition: $transition; }

  > item {
    transition: $transition;
    min-height: 20px;
    padding: 4px 8px;
    color: $titlebar-text-secondary;

    &:selected { // Seems like it :hover even with keyboard focus
      transition: none;
      background-color: $overlay-checked;
      color: $titlebar-text;
    }

    &:disabled { color: $titlebar-text-secondary-disabled; }

    label:disabled { color: inherit; } // to inherit the above color
  }

  //nested submenus
  & > item popover.menu popover.menu {
    margin-left: $space-size * 1.5;
  }

  & > item popover.menu.background popover.menu.background > contents {
    margin: 0;
  }
}


/**********************
 * Popover Base Menus *
 **********************/

popover.menu {
  box.inline-buttons {
    padding: 0 $space-size;

    button.image-button.model {
      min-height: $menuitem-size;
      min-width: $menuitem-size;
      padding: 0;
      border: none;
      outline: none;
      transition: none;

      &:selected { background-image: image($overlay-selected); }
    }
  }

  box.circular-buttons {
    padding: $space-size;

    button.circular.image-button.model {
      @extend %small-button;
      padding: $space-size;

      &:focus {
        background-color: $overlay-selected;
      }
    }
  }

  & > arrow,
  &.background > contents {
    padding: $space-size;
    box-shadow: $shadow-z6;
    background-color: $surface;
    background-clip: border-box;
    border: none; // axes borders in a composited env
    border-radius: $menu-radius;
  }

  &.background separator {
    margin: $space-size 0;
  }

  arrow.left,
  radio.left,
  check.left {
    margin-left: 0;
    margin-right: 0;
  }

  arrow.right,
  radio.right,
  check.right {
    margin-left: 0;
    margin-right: 0;
  }

  modelbutton {
    transition: background-color $duration $ease-out;
    min-height: $menuitem-size - $space-size;
    min-width: $menuitem-size * 2;
    padding: $space-size / 2 $space-size * 1.5;
    border-radius: $menuitem-radius;
    color: $text;
    font: initial;
    text-shadow: none;
    box-shadow: none;
    background: none;

    &:hover {
      transition: none;
      background-color: $overlay-hover;
    }

    &:disabled { color: $text-disabled; }

    arrow {
      &.left { -gtk-icon-source: -gtk-icontheme("go-previous-symbolic"); }
      &.right { -gtk-icon-source: -gtk-icontheme("go-next-symbolic"); }
    }
  }

  label.title {
    font-weight: bold;
    padding: 4px ($space-size + 20px); //this will fall apart with font sizing
  }
}


/************
 * Popovers *
 ************/

popover.background {
  font: initial;

  &, &:backdrop {
    background-color: transparent;
  }

  > arrow,
  > contents {
    transition: $transition-shadow;
    padding: $space-size;
    box-shadow: $shadow-z6; // TODO: this should really have a highlight
    background-color: $surface;
    border: none;
    border-radius: $menu-radius;
    color: $text;
  }

  &:backdrop {
    > arrow,
    > contents {
      box-shadow: $shadow-z2;
    }
  }

  > contents {
    > list,
    > .view,
    > toolbar {
      border-style: none;
      box-shadow: none;
      background-color: transparent;
    }

    > scrolledwindow > viewport > stack > box {
      padding: 0;
    }

    separator {
      background-color: $divider;
      margin: $space-size / 2 0;
    }

    list separator { margin: 0; }
  }

  // FIXME: Use the popover color instead of transparent as a workaround for .view
  .view:not(:selected),
  toolbar { background-color: $surface; }

  .linked > button:not(.radio) {
    &:first-child { border-radius: $menuitem-radius 0 0 $menuitem-radius; }
    &:last-child { border-radius: 0 $menuitem-radius $menuitem-radius 0; }
    &:only-child { border-radius: $menuitem-radius; }
  }

  &.menu button,
  button.model {
    min-height: 32px;
    padding: 0 8px;
    border-radius: $menuitem-radius;
  }

  .osd &,
  &.touch-selection,
  &.magnifier {
    background-color: transparent;

    > arrow,
    > contents {
      @extend %osd;
    }
  }

  &.touch-selection,
  &.magnifier {
    button { @extend %button-on-dark; }
  }

  listview {
    padding: 0;

    > row {
      padding: $space-size $space-size * 2;
      border-radius: $menuitem-radius;
      margin: 0;
    }
  }
}

magnifier {
  background-color: $base;
}

/*************
 * Notebooks *
 *************/

%tabs_tab {
  transition: $transition;
  min-height: $small-size;
  min-width: $small-size;
  padding: $space-size $space-size * 2;
  border-width: 1px;
  border-color: transparent;
  border-style: solid;
  outline: none;
  background-clip: padding-box;
  box-shadow: none;
  color: $text-secondary;
  font-weight: 500;

  &:hover {
    background-color: $solid-border;
    color: $text;
  }

  &:disabled { color: $text-secondary-disabled; }

  &:checked {
    transition: $transition;
    background-color: $base;
    background-clip: padding-box;
    border-color: $solid-border;
    color: $text;
    box-shadow: none;

    &:disabled { color: $text-disabled; }

    &.reorderable-page {
      background-color: $base;
    }
  }
}

notebook {
  frame > paned > & > header,
  &.frame > header { background-color: $base-alt; }

  &, &.frame {
    background-color: $base;
    border-radius: $corner-radius;
  }

  &.frame frame {
    > border {
      border: none;
      border-radius: $corner-radius;
    }

    > list {
      // @extend %circular_list;

      row.activatable { border-radius: $corner-radius; }
    }
  }

  &:focus tab:checked { box-shadow: none; }

  > header {
    border: none;
    background-color: $background;

    &.top {
      border-radius: $corner-radius $corner-radius 0 0;
      box-shadow: inset 0 -1px $solid-border;

      > tabs {
        margin-bottom: -1px;
        margin-top: 4px;

        > tab {
          border-radius: $corner-radius $corner-radius 0 0;
          border-bottom: none;
        }
      }
    }

    &.bottom {
      border-radius: 0 0 $corner-radius $corner-radius;
      box-shadow: inset 0 1px $solid-border;

      > tabs {
        margin-top: -1px;
        margin-bottom: 4px;

        > tab {
          border-radius: 0 0 $corner-radius $corner-radius;
          border-top: none;
        }
      }
    }

    &.left {
      border-radius: $corner-radius 0 0 $corner-radius;
      box-shadow: inset -1px 0 $solid-border;

      > tabs {
        margin-right: -1px;
        margin-left: 4px;

        > tab {
          border-radius: $corner-radius 0 0 $corner-radius;
          border-right: none;
        }
      }
    }

    &.right {
      border-radius: 0 $corner-radius $corner-radius 0;
      box-shadow: inset 1px 0 $solid-border;

      > tabs {
        margin-left: -1px;
        margin-right: 4px;

        > tab {
          border-radius: 0 $corner-radius $corner-radius 0;
          border-left: none;
        }
      }
    }

    &.top > tabs > arrow {
      @extend %notebook_vert_arrows;

      border-top-style: none;
    }

    &.bottom > tabs > arrow {
      @extend %notebook_vert_arrows;

      border-bottom-style: none;
    }

    @at-root %notebook_vert_arrows {
      padding-left: 4px;
      padding-right: 4px;

      &.down {
        margin-left: -8px;
        -gtk-icon-source: -gtk-icontheme('pan-start-symbolic');
      }

      &.up {
        margin-right: -8px;
        -gtk-icon-source: -gtk-icontheme('pan-end-symbolic');
      }
    }

    &.left > tabs > arrow {
      @extend %notebook_horz_arrows;

      border-left-style: none;
    }

    &.right > tabs > arrow {
      @extend %notebook_horz_arrows;

      border-right-style: none;
    }

    @at-root %notebook_horz_arrows {
      padding-top: 4px;
      padding-bottom: 4px;

      &.down {
        margin-top: -8px;
        -gtk-icon-source: -gtk-icontheme('pan-up-symbolic');
      }

      &.up {
        margin-bottom: -8px;
        -gtk-icon-source: -gtk-icontheme('pan-down-symbolic');
      }
    }

    > tabs > arrow {
      @extend %button-flat-simple;

      min-height: 16px;
      min-width: 16px;
      border-radius: 0;
    }

    tab {
      @extend %tabs_tab;

      // FIXME: The tab node doesn't have :drop(active), instead its child box has it.
      > box {
        transition: background-color $duration $ease-out;
        margin: -$space-size -12px;
        padding: $space-size 12px;

        &:drop(active) {
          background-color: $divider;
          color: $text;
        }
      }

      // colors the button like the label, overridden otherwise
      button.flat {
        @extend %small-button;

        &:last-child {
          margin-left: $space-size;
          margin-right: $space-size - 12px;
        }

        &:first-child {
          margin-left: $space-size - 12px;
          margin-right: $space-size;
        }
      }
    }

    &.top,
    &.bottom {
      tabs {
        padding-left: 8px;
        padding-right: 8px;

        &:not(:only-child) {
          &:first-child { margin-left: 0; }

          &:last-child { margin-right: 0; }
        }

        tab.reorderable-page { border-style: solid; }
      }
    }

    &.left,
    &.right {
      tabs {
        padding-top: 8px;
        padding-bottom: 8px;

        &:not(:only-child) {
          &:first-child { margin-top: 0; }

          &:last-child { margin-bottom: 0; }
        }

        tab.reorderable-page { border-style: solid; }
      }
    }
  }

  > stack:not(:only-child) { // the :not(:only-child) is for "hidden" notebooks
    background-color: transparent;
    border-radius: $corner-radius;
  }
}


/**************
 * Scrollbars *
 **************/
scrollbar {
  $_slider_min_length: 24px;

  transition: $transition;
  background-color: $base;

  // scrollbar border
  &.top { border-bottom: 1px solid $divider; }
  &.bottom { border-top: 1px solid $divider; }
  &.left { border-right: 1px solid $divider; }
  &.right { border-left: 1px solid $divider; }

  > range > trough {
    box-shadow: none;
    outline: none;
    background: none;

    > slider {
      transition: background-color $duration $ease-out;
      min-width: 8px;
      min-height: 8px;
      border: 4px solid transparent;
      border-radius: $circular-radius;
      background-clip: padding-box;
      background-color: $text-disabled;
      box-shadow: none;
      outline: none;

      &:hover { background-color: $text-secondary; }

      &:active { background-color: $text; }

      &:disabled { background-color: $text-secondary-disabled; }
    }
  }

  > range.fine-tune {
    > trough > slider {
      min-width: 4px;
      min-height: 4px;
    }

    &.horizontal > trough > slider { margin: 2px 0; }

    &.vertical > trough > slider { margin: 0 2px; }
  }

  &.overlay-indicator {
    &:not(.fine-tune) > range > trough > slider {
      transition-property: background-color, min-height, min-width;
    }

    &:not(.dragging):not(.hovering) {
      border-color: transparent;
      background-color: transparent;
      box-shadow: none;
      outline: none;

      > range > trough > slider {
        min-width: 4px;
        min-height: 4px;
        margin: 4px - 1px;
        border: 1px solid rgba($base, 0.3);
        box-shadow: none;
        outline: none;
      }

      button {
        min-width: 4px;
        min-height: 4px;
        margin: 4px - 1px;
        border: 1px solid rgba($base, 0.3);
        border-radius: $circular-radius;
        background-color: $text-disabled;
        background-clip: padding-box;
        -gtk-icon-source: none;

        &:disabled { background-color: $text-secondary-disabled; }
      }

      &.horizontal {
        > range > trough > slider { min-width: $_slider_min_length; }

        button { min-width: 8px; }
      }

      &.vertical {
        > range > trough > slider { min-height: $_slider_min_length; }

        button { min-height: 8px; }
      }
    }

    &.dragging,
    &.hovering { background-color: rgba($surface, 0.9); }
  }

  &.horizontal > range > trough > slider { min-width: $_slider_min_length; }

  &.vertical > range > trough > slider { min-height: $_slider_min_length; }

  // button styling
  button {
    @extend %button-flat-simple;

    min-width: 16px;
    min-height: 16px;
    padding: 0;
    border-radius: 0;
  }

  // button icons
  &.vertical {
    button {
      &.down { -gtk-icon-source: -gtk-icontheme('pan-down-symbolic'); }

      &.up { -gtk-icon-source: -gtk-icontheme('pan-up-symbolic'); }
    }
  }

  &.horizontal {
    button {
      &.down { -gtk-icon-source: -gtk-icontheme('pan-end-symbolic'); }

      &.up { -gtk-icon-source: -gtk-icontheme('pan-start-symbolic'); }
    }
  }
}


/**********
 * Switch *
 **********/
switch {
  transition: all $duration $ease-out;
  margin: $space-size 0;
  padding: 0 2px;
  border: 5px solid transparent;
  border-radius: $circular-radius;
  background-color: $track;
  background-clip: padding-box;
  font-size: 0;
  color: transparent;

  &:checked { background-color: rgba($primary, 0.5); }

  &:disabled { opacity: 0.5; }

  // hide on/off icons for >=3.24.5
  image {
    margin: -8px;
    color: transparent;
  }

  > slider {
    transition: all $duration $ease-out;
    min-width: 20px;
    min-height: 20px;
    margin: -3px -2px;
    border-radius: $circular-radius;
    outline: none;
    box-shadow: 0 0 0 10px transparent, $shadow-z1;
    background-color: $surface;
  }

  &:focus > slider { box-shadow: 0 0 0 10px $overlay-focus, $shadow-z1; }

  &:hover > slider { box-shadow: 0 0 0 10px $overlay-hover, $shadow-z1; }

  &:focus:hover > slider { box-shadow: 0 0 0 10px $overlay-focus-hover, $shadow-z1; }

  &:checked > slider {
    background-color: $primary;
    color: $primary;
  }

  row:selected & { }
}


/*************************
 * Check and Radio items *
 *************************/
// draw regular check and radio items using our PNG assets
// all assets are rendered from assets.svg. never add pngs directly

// selection-mode
.view.content-view.check:not(list),
.content-view .tile check:not(list) {
  min-height: 40px;
  min-width: 40px;
  margin: 0;
  padding: 0;
  box-shadow: none;
  background-color: transparent;
  background-image: none;
  -gtk-icon-shadow: $icon-shadow-z2;

  &:hover, &:active { -gtk-icon-shadow: $icon-shadow-z4; }

  @each $s, $as in ('', '-unchecked'),
                   (':checked', '-checked') {
    &#{$s} {
      -gtk-icon-source: -gtk-scaled(url("assets/selectionmode-checkbox#{$as}#{$asset-suffix}.png"),
                                    url("assets/selectionmode-checkbox#{$as}#{$asset-suffix}@2.png"));
    }
  }
}

checkbutton,
radiobutton {
  outline: none;
  border-spacing: 4px;
}

checkbutton.text-button,
radiobutton.text-button {
  // this is for a nice focus on check and radios text
  padding: 2px;

  label:not(:only-child) { margin: 0 4px; }
}

$check_radio_size: 40px;
$check_radio_icon_size: ($space-size + 6px) * 2;

check,
radio {
  min-height: $check_radio_icon_size;
  min-width: $check_radio_icon_size;
  margin: -($space-size + 2px);
  padding: ($space-size + 2px);
  border: none;

  @extend %button-flat-simple;
  @extend %circular-button;

  &:checked, &:indeterminate {
    color: $check_radio_primary;

    &:disabled { color: $text-secondary-disabled; }
  }

  &:not(:hover):focus { box-shadow: inset 0 0 0 9999px transparent; }

  popover modelbutton.flat & {
    &, &:focus, &:hover, &:focus:hover, &:active, &:disabled {
      transition: none; // FIXME: this is a workaround for a popover check/radio long transition issue
      box-shadow: none;
      background: none;
      border: none;
    }

    &:not(:checked):not(:indeterminate):not(:disabled) { color: $text-secondary; }

    &.left:dir(rtl) {
      margin-left: -12px;
      margin-right: -4px;
    }

    &.right:dir(ltr) {
      margin-left: -4px;
      margin-right: -12px;
    }
  }

  popover.menu & {
    transition: none;
    margin: 0; // this is a workaround for a menu check/radio size allocation issue
    padding: 0;

    &:dir(ltr) { margin-right: 8px; }

    &:dir(rtl) { margin-left: 8px; }

    &:not(:checked):not(:indeterminate):not(:disabled) { color: $text-secondary; }

    &, &:hover, &:disabled {
      box-shadow: none;
      // color: inherit;
    }
  }
}

%check,
check {
  -gtk-icon-size: 24px;
  -gtk-icon-source: -gtk-scaled(-gtk-recolor(url("assets/scalable/unchecked-symbolic.svg")),
                                -gtk-recolor(url("assets/scalable/unchecked-symbolic@2.svg")));

  &:checked {
    -gtk-icon-source: -gtk-scaled(-gtk-recolor(url("assets/scalable/checkbox-checked-symbolic.svg")),
                                  -gtk-recolor(url("assets/scalable/checkbox-checked-symbolic@2.svg")));
  }

  &:indeterminate {
    -gtk-icon-source: -gtk-scaled(-gtk-recolor(url("assets/scalable/mixed-symbolic.svg")),
                                  -gtk-recolor(url("assets/scalable/mixed-symbolic@2.svg")));
  }
}

%radio,
radio {
  -gtk-icon-size: 24px;
  -gtk-icon-source: -gtk-scaled(-gtk-recolor(url("assets/scalable/unchecked-symbolic.svg")),
                                -gtk-recolor(url("assets/scalable/unchecked-symbolic@2.svg")));

  &:checked {
    -gtk-icon-source: -gtk-scaled(-gtk-recolor(url("assets/scalable/radio-checked-symbolic.svg")),
                                  -gtk-recolor(url("assets/scalable/radio-checked-symbolic@2.svg")));
  }

  &:indeterminate {
    -gtk-icon-source: -gtk-scaled(-gtk-recolor(url("assets/scalable/mixed-symbolic.svg")),
                                  -gtk-recolor(url("assets/scalable/mixed-symbolic@2.svg")));
  }
}

%small_check,
popover.menu check {
  min-height: 18px;
  min-width: 18px;
  -gtk-icon-size: 18px;

  -gtk-icon-source: -gtk-scaled(-gtk-recolor(url("assets/scalable/small-unchecked-symbolic.svg")),
                                -gtk-recolor(url("assets/scalable/small-unchecked-symbolic@2.svg")));

  &:checked {
    -gtk-icon-source: -gtk-scaled(-gtk-recolor(url("assets/scalable/small-checkbox-checked-symbolic.svg")),
                                  -gtk-recolor(url("assets/scalable/small-checkbox-checked-symbolic@2.svg")));
  }

  &:indeterminate {
    -gtk-icon-source: -gtk-scaled(-gtk-recolor(url("assets/scalable/small-mixed-symbolic.svg")),
                                  -gtk-recolor(url("assets/scalable/small-mixed-symbolic@2.svg")));
  }
}

%small_radio,
popover.menu radio {
  min-height: 18px;
  min-width: 18px;
  border-image: none;
  -gtk-icon-size: 18px;

  -gtk-icon-source: -gtk-scaled(-gtk-recolor(url("assets/scalable/small-unchecked-symbolic.svg")),
                                -gtk-recolor(url("assets/scalable/small-unchecked-symbolic@2.svg")));

  &:checked {
    -gtk-icon-source: -gtk-scaled(-gtk-recolor(url("assets/scalable/small-radio-checked-symbolic.svg")),
                                  -gtk-recolor(url("assets/scalable/small-radio-checked-symbolic@2.svg")));
  }

  &:indeterminate {
    -gtk-icon-source: -gtk-scaled(-gtk-recolor(url("assets/scalable/small-mixed-symbolic.svg")),
                                  -gtk-recolor(url("assets/scalable/small-mixed-symbolic@2.svg")));
  }
}

// ANIMATION:
// this is made with those pretty convoluted transitions, since checks and radios have to animate only on state changes,
// the transformation is set on the active state and it get reset on the checked state.
// radio:not(:checked):active { -gtk-icon-transform: scale(0); }

treeview.view,
columnview.view {
  check, radio {
    padding: 0;
    box-shadow: none;
    background: none;

    color: $text-secondary;

    &:hover, &:active { color: $text; }

    &:disabled { color: $text-secondary-disabled; }

    &:checked, &:indeterminate { color: $check_radio_primary; }

    &:checked:disabled, &:indeterminate:disabled { color: $text-secondary-disabled; }
  }

  &:hover, &:selected, &:focus, &:focus-within {
    check, radio {
      box-shadow: none;
      background-color: transparent;
    }
  }
}

treeview.view radio:checked {
  -gtk-icon-source: -gtk-recolor(url("assets/scalable/radio-checked-symbolic.svg"));
  border-image: none;
}


/************
 * GtkScale *
 ************/
scale {
  // sizing
  $_marks_length: 8px;
  $_marks_distance: 7px;

  $trough_size: 2px;
  $finetune_trough_size: 4px;

  $slider_size: 32px;

  $slider_margin: -($slider_size - $trough_size) / 2;
  $finetune_slider_margin: -($slider_size - $finetune_trough_size) / 2;

  $color_slider_margin: -($slider_size) * 3 / 4;
  $color_marks_slider_margin: -($slider_size - 16px) - $color_slider_margin;

  min-height: $trough_size;
  min-width: $trough_size;

  &.horizontal { padding: ($medium-size - $trough_size) / 2 12px; }

  &.vertical { padding: 12px ($medium-size - $trough_size) / 2; }

  // click-and-hold the slider to activate
  &.fine-tune {
    &.horizontal {
      min-height: $finetune_trough_size;
      padding-top: ($medium-size - $finetune_trough_size) / 2;
      padding-bottom: ($medium-size - $finetune_trough_size) / 2;
    }

    &.vertical {
      min-width: $finetune_trough_size;
      padding-left: ($medium-size - $finetune_trough_size) / 2;
      padding-right: ($medium-size - $finetune_trough_size) / 2;
    }

    // to make the trough grow in fine-tune mode
    > trough > slider {
      min-height: $slider_size;
      min-width: $slider_size;
      margin: $finetune_slider_margin;
    }
  }

  // the backing bit
  > trough {
    transition: background-color $duration $ease-out;
    outline: none;
    background-color: $track;

    &:disabled { background-color: $track-disabled; }
  }

  // the colored part of the backing bit
  > trough > highlight {
    transition: background-image $duration $ease-out;
    background-image: image($primary);

    &:disabled {
      background-color: $background;
      background-image: image($text-secondary-disabled);
    }
  }

  // this is another differently styled part of the backing bit, the most relevant use case is for example
  // in media player to indicate how much video stream as been cached
  > trough > fill {
    transition: background-color $duration $ease-out;
    background-color: $track;

    &:disabled { background-color: transparent; }
  }

  > trough > slider {
    transition: $transition;
    background-repeat: no-repeat;
    background-position: center;
    background-size: auto;
    min-height: $slider_size;
    min-width: $slider_size;
    margin: $slider_margin;
    border-radius: 50%;
    color: $primary;
    background-color: transparent;
    box-shadow: none;
    outline: none;
    border: none;

    @each $s, $as in ('', ''),
                     (':disabled', '-disabled') {
      &#{$s} {
        $_url: 'assets/scale-slider#{$as}#{$asset-suffix}';

        background-image: -gtk-scaled(url('#{$_url}.png'), url('#{$_url}@2.png'));
      }
    }

    &:focus { background-color: $overlay-focus; }

    &:hover { background-color: $overlay-hover; }

    &:focus:hover { background-color: $overlay-focus-hover; }

    &:active {
      $_url: 'assets/scale-slider#{$asset-suffix}';

      background-color: $overlay-active;
      background-image: -gtk-scaled(url('#{$_url}.png'), url('#{$_url}@2.png'));
      background-size: auto, 0% 0%;
    }
  }

  > marks,
  > value { color: $text-secondary; }

  > marks indicator {
    background-color: $track;
    color: transparent;
  }

  //marks margins
  @each $scale_orient, $marks_class, $marks_pos, $marks_margin in (horizontal, top, top, bottom),
                                                                  (horizontal, bottom, bottom, top),
                                                                  (vertical, top, left, right),
                                                                  (vertical, bottom, right, left) {
    &.#{$scale_orient} marks {
      &.#{$marks_class} {
        margin-#{$marks_margin}: $_marks_distance;
        margin-#{$marks_pos}: -($_marks_distance + $_marks_length);
      }
    }

    &.#{$scale_orient}.fine-tune marks {
      &.#{$marks_class} {
        margin-#{$marks_margin}: $_marks_distance - 1px;
        margin-#{$marks_pos}: -($_marks_distance + $_marks_length - 1px);
      }
    }
  }

  &.horizontal {
    > marks indicator {
      min-height: $_marks_length;
      min-width: 1px;
    }
  }

  &.vertical {
    > marks indicator {
      min-height: 1px;
      min-width: $_marks_length;
    }
  }

  &.marks-before:not(.marks-after),
  &.marks-after:not(.marks-before) {
    > trough > slider {
      transform: none;
      box-shadow: none;
      border: none;
      transition: $transition;

      &:disabled {
        box-shadow: none;
      }
    }
  }

  // *WARNING* scale with marks madness following

  @each $dir_class, $dir_infix in ('horizontal', 'horz'),
                                  ('vertical', 'vert') {
    @each $marks_infix, $marks_class in ('marks-before', 'marks-before:not(.marks-after)'),
                                        ('marks-after', 'marks-after:not(.marks-before)') {
      &.#{$dir_class}.#{$marks_class} {
        > trough > slider {
          @each $state, $state_infix in ('', ''),
                                        (':disabled', '-disabled') {
            &#{$state} {
              $_scale_asset: 'assets/scale-#{$dir_infix}-#{$marks_infix}-slider#{$state_infix}#{$asset-suffix}';

              background-image: -gtk-scaled(url('#{$_scale_asset}.png'), url('#{$_scale_asset}@2.png'));
            }
          }

          &:active {
            $_scale_asset: 'assets/scale-#{$dir_infix}-#{$marks_infix}-slider#{$asset-suffix}';

            background-image: -gtk-scaled(url('#{$_scale_asset}.png'), url('#{$_scale_asset}@2.png'));
          }
        }
      }
    }
  }

  &.color {
    min-height: 0;
    min-width: 0;

    &.horizontal {
      padding: 0 0 12px 0;

      > trough > slider {
        &:dir(ltr), &:dir(rtl) { // specificity bump
          margin-bottom: $color_slider_margin;
          margin-top: $color_marks_slider_margin;
        }
      }
    }

    &.vertical {
      &:dir(ltr) {
        padding: 0 0 0 12px;

        > trough > slider {
          margin-left: $color_slider_margin;
          margin-right: $color_marks_slider_margin;
        }
      }

      &:dir(rtl) {
        padding: 0 12px 0 0;

        > trough > slider {
          margin-right: $color_slider_margin;
          margin-left: $color_marks_slider_margin;
        }
      }
    }
  }
}


/*****************
 * Progress bars *
 *****************/
progressbar {
  // sizing
  &.horizontal {
    trough,
    progress { min-height: $bar-size; }
  }

  &.vertical {
    trough,
    progress { min-width: $bar-size; }
  }

  // FIXME: insensitive state missing and some other state should be set probably
  color: $text-secondary;
  font-size: smaller;

  trough {
    border-radius: $corner-radius;
    background-color: $track-disabled;
  }

  progress {
    border-radius: $corner-radius;
    background-color: $primary;
  }

  &.osd { // progressbar.osd used for epiphany page loading progress
    min-width: $bar-size;
    min-height: $bar-size;
    background-color: transparent;

    trough { background-color: transparent; }

    progress { background-color: $primary; }
  }

  trough.empty progress { all: unset; } // makes the progress indicator disappear, when the fraction is 0
}


/*************
 * Level Bar *
 *************/
levelbar {
  &.horizontal {
    block { min-height: $bar-size; }

    &.discrete block {
      min-width: $medium-size;

      &:not(:last-child) { margin-right: 2px; }
    }
  }

  &.vertical {
    block { min-width: $bar-size; }

    &.discrete block {
      min-height: $medium-size;

      &:not(:last-child) { margin-bottom: 2px; }
    }
  }

  // imitate the entry style
  trough {
    // padding: 2px;
    border-radius: $corner-radius;
    // box-shadow: $shadow-z1;
    // background-color: $base;

    // &:disabled { background-color: $base-alt; }
  }

  block {
    &.low { background-color: $warning; }

    &.high,
    &:not(.empty) { background-color: $primary; }

    &.full { background-color: $success; }

    &.empty { background-color: $track-disabled; }
  }
}


/****************
 * Print dialog *
*****************/
window.dialog.print {
  drawing {
    color: $text;
    background: none;
    border: none;
    padding: 0;

    paper {
      padding: 0;
      border: 1px solid $divider;
      background-color: $base;
      color: $text;
    }
  }

  .dialog-action-box { margin: 12px; }
}


/**********
 * Frames *
 **********/

frame,
.frame {
  border: 1px solid $divider;

  > list { border: none; }

  &.view { border-radius: $corner-radius; }

  &.flat { border-style: none; }
}

frame {
  border-radius: $corner-radius;

  > label {
    margin: 4px;
  }

  &.flat > border,
  statusbar & > border { border: none; } // for backward compatibility
}

actionbar > revealer > box {
  padding: $space-size;
  border-spacing: $space-size;
  border-top: 1px solid $divider;
  background-color: $base;
  background-clip: border-box;
  box-shadow: none;
}

statusbar {
  padding: $space-size $space-size * 3;
}

scrolledwindow {
  viewport.frame { // avoid double borders when viewport inside scrolled window
    border: none;
  }

  stack &.frame {
    // border-radius: $corner-radius;

    viewport.frame list { border: none; }
  }

  // This is used when content is touch-dragged past boundaries.
  // draws a box on top of the content, the size changes programmatically.
  @at-root overshoot {
    &.top { @include overshoot(top); }

    &.bottom { @include overshoot(bottom); }

    &.left { @include overshoot(left); }

    &.right { @include overshoot(right); }
  }

  // Overflow indication, works similarly to the overshoot, the size if fixed tho.
  // @at-root undershoot {
  //   &.top { @include undershoot(top); }
  //
  //   &.bottom { @include undershoot(bottom); }
  //
  //   &.left { @include undershoot(left); }
  //
  //   &.right { @include undershoot(right); }
  // }

  @at-root junction { // the small square between two scrollbars
    border: none;
    background-color: $base;
  }
}

// vbox and hbox separators
separator {
  min-width: 1px;
  min-height: 1px;
  background-color: $divider;

  &.spacer {
    background-color: transparent;

    &.horizontal { min-width: $space-size * 2; }
    &.vertical { min-height: $space-size * 2; }
  }
}

%hide_separators {
  min-width: 0;
  min-height: 0;
  background-color: transparent;
}


/*********
 * Lists *
 *********/
listview,
list {
  border-color: $divider;
  background-color: $base;
  background-clip: padding-box;
  color: $text-secondary;

  > row {
    padding: 2px;
    background-clip: padding-box;
  }

  > row.expander { padding: 0px; }
  > row.expander .row-header { padding: 2px; }

  &.horizontal row.separator,
  &.separators.horizontal > row:not(.separator) {
    border-left: 1px solid $divider;
  }

  &:not(.horizontal) row.separator,
  &.separators:not(.horizontal) > row:not(.separator) {
    border-bottom: 1px solid $divider;
  }
}

list.frame { border-radius: $corner-radius; }

row {
  background-clip: padding-box;

  @at-root %row_activatable, &.activatable {
    transition: $transition;
    outline: none;

    &:focus {
      box-shadow: none;
      background-color: $overlay-normal;
      color: $text;
    }

    &:hover {
      transition: $transition,
                  box-shadow 0ms;
      background-color: $overlay-hover;
    }

    &.has-open-popup, // this is for indicathing which row generated a popover see https://bugzilla.gnome.org/show_bug.cgi?id=754411
    &:active {
      transition: $transition;
      background-color: $overlay-active;
    }

    button.circular {
      @extend %button-flat-simple;
    }

    button:hover &, button:active &, button:checked & {
      background-color: transparent;
    }

    button:checked & {
      color: on($primary);
    }
  }

  &:selected {
    @extend %selected_items;
    color: inherit; // for overlays

    image,
    label { color: $text; }

    button image,
    button label { color: inherit; }

    &:disabled {
      image,
      label { color: $text-disabled; }
    }
  }
}

treeexpander {
  border-spacing: 4px;
}

columnview {
  // move padding to child cells
  > listview > row {
    padding: 0;

    // align horizontal sizing with header buttons
    > cell {
      padding: 8px 6px;

      &:not(:first-child) {
        border-left: 1px solid transparent;
      }
    }
  }

  > header > button {
    padding-left: 6px;
    padding-right: 6px;
    border-left: 1px solid transparent;

    &:first-child {
      border-left-width: 0;
    }
  }

  // make column separators visible when :show-column-separators is true
  &.column-separators {
    > listview > row > cell,
    > header > button {
      border-left-color: $divider;
    }
  }

  > listview:not(.horizontal).separators > row:not(.separator) {
    border-top: 1px solid $divider;
    border-bottom: none;
  }

  // shrink vertically for .data-table
  &.data-table > listview > row > cell {
    padding-top: 2px;
    padding-bottom: 2px;
  }

  ~ undershoot.top {
    box-shadow: inset 0 1px $divider;
  }

  row:not(:selected) cell editablelabel {
    &:not(.editing):focus-within {
      outline: 2px solid $overlay-selected;
    }

    &.editing:focus-within {
      outline: 2px solid $primary;
    }

    &.editing text selection {
      color: on($primary);
      background-color: $primary;
    }
  }
}

.rich-list { /* rich lists usually containing other widgets than just labels/text */
  & > row {
    padding: $space-size * 1.5 $space-size * 2;
    min-height: 32px; /* should be tall even when only containing a label */

    & > box {
      border-spacing: $space-size * 2;
    }
  }
}

/****************
 * AdwActionRow *
 ****************/

row {
  label.subtitle {
    font-size: smaller;
    @extend .dim-label;
  }

  > box.header {
    margin-left: $space-size * 2;
    margin-right: $space-size * 2;
    min-height: $large-size;

    > .icon:disabled {
      filter: opacity(0.35);
    }

    > box.title {
      margin-top: $space-size;
      margin-bottom: $space-size;
      border-spacing: $space-size / 2;
    }
  }
}

/***************
 * AdwComboRow *
 ***************/

row.combo {
  image.dropdown-arrow:disabled {
    filter: opacity(0.35);
  }

  listview.inline {
    background: none;
    border: none;
    box-shadow: none;
    color: inherit;

    &, &:disabled {
      background: none;
      color: inherit;
    }
  }

  popover > contents {
    min-width: 120px;
  }
}

/******************
 * AdwExpanderRow *
 ******************/

@mixin margin-start($margin) {
  &:dir(ltr) {
    margin-left: $margin;
  }

  &:dir(rtl) {
    margin-right: $margin;
  }
}

$boxed-radius: $corner-radius - 1px;

%boxed_list_row {
  transition: 200ms $ease-out;
  color: $text-secondary;
  border-bottom: 1px solid $divider;

  .osd &:focus:focus-visible {
    outline-color: $fill;
  }
}

row.expander {
  // Drop transparent background on expander rows to let nested rows handle it,
  // avoiding double highlights.
  background: none;
  padding: 0px;

  > box > list {
    background: none;
    color: inherit;
  }

  list.nested {
    background-color: $base;
    color: inherit;
  }

  list.nested > row {
    @extend %boxed_list_row;
  }

  // AdwExpanderRow arrow rotation

  image.expander-row-arrow {
    transition: 200ms $ease-out;
    @include margin-start(6px);
  }

  &:checked image.expander-row-arrow {
    -gtk-icon-transform: rotate(0turn);
  }

  &:not(:checked) image.expander-row-arrow {
    @extend .dim-label;

    &:dir(ltr) {
      -gtk-icon-transform: rotate(-0.25turn);
    }

    &:dir(rtl) {
      -gtk-icon-transform: rotate(0.25turn);
    }
  }

  &:checked image.expander-row-arrow:not(:disabled) {
    color: $primary;
  }

  .osd &:checked image.expander-row-arrow:not(:disabled) {
    color: inherit;
  }

  image.expander-row-arrow:disabled {
    filter: opacity(0.35);
  }
}

/*****************
 * Boxed Lists *
 *****************/

// Deprecated: use .boxed-list instead
list.content,
list.boxed-list {
  @extend %card;

  > row {
    // Regular rows and expander header rows background
    &, &.expander row.header {
      @extend %boxed_list_row;
    }

    &.expander {
      border: none;
    }

    // Rounded top
    &:first-child {
      &, &.expander row.header {
        border-top-left-radius: $boxed-radius;
        border-top-right-radius: $boxed-radius;
      }
    }

    // Rounded bottom
    &:last-child, &:only-child {
      &,
      &.expander:not(:checked),
      &.expander:not(:checked) row.header,
      &.expander:checked list.nested,
      &.expander:checked list.nested > row:last-child {
        border-bottom-left-radius: $boxed-radius;
        border-bottom-right-radius: $boxed-radius;
        border-bottom-width: 0;
      }
    }
  }
}

/*********************
 * App Notifications *
 *********************/
.app-notification {
  @extend %toolbar_osd;
  margin: 8px;
  border-spacing: $space-size * 1.5;
  padding: $space-size * 1.5;
  border: none;

  button {
    @extend %button-flat;

    &.text-button:not(:disabled) { color: $primary; }
  }

  &.frame,
  border { border-style: none; }
}


/*************
 * Expanders *
 *************/
expander {
  transition: all $duration $ease-out;
  min-width: 16px;
  min-height: 16px;
  color: $text-secondary;
  -gtk-icon-source: -gtk-icontheme('pan-end-symbolic');

  &:dir(rtl) { -gtk-icon-source: -gtk-icontheme('pan-end-symbolic-rtl'); }

  &:hover, &:active { color: $text; }

  &:disabled { color: $text-secondary-disabled; }
}

expander-widget {
  > box > title {
    border-radius: $corner-radius;

    &:hover > expander {
      color: $text-secondary; //only lightens the icon
    }
  }
}

.navigation-sidebar,
placessidebar,
stackswitcher,
expander-widget {
  &:not(decoration):not(window):drop(active):focus,
  &:not(decoration):not(window):drop(active) {
    box-shadow: none;
  }
}


/************
 * Calendar *
 ************/
calendar {
  padding: 0;
  border: 1px solid $divider;
  border-radius: $corner-radius;
  color: $text;

  &:disabled { color: $text-disabled; }

  &:selected {
    @extend %selected_items;

    border-radius: $corner-radius;
  }

  > header {
    padding: $space-size / 2;
    border-bottom: 1px solid $divider;

    > button {
      min-height: $small-size;

      @extend %button-flat-simple;
    }
  }

  > grid {
    margin: $space-size / 2;

    > label {
      border-radius: $circular-radius;
      margin: 0;
    }

    > label.today {
      @extend %selected_items_color;

      &:selected {
        box-shadow: none;
        @extend %selected_items_primary;
      }
    }

    > label:focus {
      outline-style: none;
    }

    > label.day-number {
      padding: $space-size*1.5;

      &:selected {
        @extend %selected_items;
      }
    }

    > label.day-number.other-month {
      color: gtkalpha(currentColor, 0.3);
    }
  }
}


/***********
 * Dialogs *
 ***********/
window.dialog.message { // Message Dialog styling
  &.background {
    background-color: $surface;
    background-image: none;
  }

  box.dialog-vbox.vertical {
    border-spacing: 10px;
  }

  .titlebar {
    min-height: $small-size;
    border-style: none;
    box-shadow: inset 0 1px highlight($surface);
    background-color: $surface;
    color: $text;

    &:backdrop {
      background-color: $surface;
      color: $text-secondary;
    }
  }

  &.csd { // rounded bottom border styling for csd version
    .dialog-action-area {
      // margin-top: -$space-size;
      padding: $space-size;
      border: none;
      box-shadow: none;

      > button {
        @extend %button-flat;
        border: none;
        box-shadow: none;

        &, &:first-child, &:last-child { border-radius: $circular-radius; }

        &:not(:last-child) { margin-right: $space-size; }

        &:not(:disabled) { color: $primary; }

        // &.suggested-action:not(:disabled) { color: $suggested; }

        &.destructive-action:not(:disabled) { color: $destructive; }
      }
    }
  }
}

filechooser {
  .dialog-action-box { border-top: 1px solid $divider; }

  #pathbarbox {
    border-bottom: 1px solid $divider;
    background-color: $background;

    > stack > box > button { // The new folder button
      @extend %button-flat;
      @extend %circular-button;
    }
  }

  stack.view {
    frame > border { border: none; }
  }
}

filechooserbutton > button > box {
  border-spacing: $space-size;
}

filechooserbutton:drop(active) {
  box-shadow: none;
  border-color: transparent;
}

// aboutdialog
window.aboutdialog {
  stack scrolledwindow.frame {
    &, > .view, > .view > text {
      border-radius: $corner-radius;
    }
  }

  .large-icons {
    -gtk-icon-size: 128px;
  }
}

/***********
 * Sidebar *
 ***********/
.sidebar {
  border-style: none;
  background-color: $base-alt;

  &:not(separator) {
    @at-root %sidebar_left,
    &:dir(ltr),
    &.left,
    &.left:dir(rtl) {
      border-right: 1px solid $divider;
      border-left-style: none;
    }

    @at-root %sidebar_right,
    &:dir(rtl),
    &.right {
      border-left: 1px solid $divider;
      border-right-style: none;
    }
  }

  listview.view,
  list { background-color: transparent; }

  paned & { &.left, &.right, &.left:dir(rtl), &:dir(rtl), &:dir(ltr), & { border-style: none; }}
}

stacksidebar {
  + separator.vertical,
  separator.horizontal { @extend %hide_separators; }

  list {
    padding: $space-size;
    background-color: $base-alt; // This should not be necessary, but the parent stacksidebar ignores background-color.
  }

  row {
    min-height: $small-size;
    padding: $space-size $space-size * 1.5;
    border-radius: $corner-radius / 2;

    &:selected {
      @extend %selected_items_color;
      font-weight: 500;
    }

    + row { margin-top: 4px; }

    > label {
      padding-left: $space-size;
      padding-right: $space-size;
      color: inherit;
    }

    &.needs-attention > label { @extend %needs-attention; }
  }
}

separator.sidebar {
  background-color: $divider;
  border-right: none;

  &.selection-mode,
  .selection-mode & {
    background-color: rgba(white, 0.15);
  }

  &.spacer {
    background-color: transparent;
  }
}


/**********************
 * Navigation Sidebar *
 **********************/

.navigation-sidebar {
  padding: $space-size 0; //only vertical padding. horizontal row size would clip
  border-right: none;

  > row {
    min-height: $small-size;
    padding: $space-size $space-size * 1.5;
    border-radius: 0 $circular-radius $circular-radius 0;
    margin: 0 $space-size 0 0;

    &:hover,
    &:focus-visible:focus-within {
      background-color: $overlay-hover;
    }

    &:selected {
      background-color: $overlay-checked;
      color: $primary;

      label, image { color: $primary; }

      &:hover {
        background-color: $overlay-focus-hover;
      }

      &:focus-visible:focus-within {
        outline: none;
        background-color: $overlay-focus;
        &:hover { background-color: $overlay-focus-hover; }
      }
    }

    &:disabled { color: $text-disabled; }
  }

  > separator { margin: $space-size 0; }
}

/****************
 * File chooser *
 ****************/
// dim the sidebar icons, see bug #786613 for details on this oddity
row image.sidebar-icon {
  transition: color $duration $ease-out;
  color: $text-secondary;

  &:disabled { color: $text-secondary-disabled; }
}

placessidebar {
  > viewport.frame { border-style: none; }

  .navigation-sidebar {
    padding: $space-size 0;

    > row {
      // Needs overriding of the GtkListBoxRow padding
      min-height: 32px;
      margin: 0 4px 0 0; // Remove unwanted hard-coded vertical margins with -1px
      padding: $space-size / 2;
      border-radius: 0 $circular_radius $circular_radius 0;

      // Using margins/padding directly in the SidebarRow
      // will make the animation of the new bookmark row jump
      > revealer { padding: 0 8px 0 16px; }

      &:selected {
        background-color: $overlay-checked;
        color: $primary;
        font-weight: 500;

        image.sidebar-icon { color: $primary; }
      }

      &:disabled { color: $text-disabled; }

      image.sidebar-icon {
        &:dir(ltr) { padding-right: 8px; }
        &:dir(rtl) { padding-left: 8px; }
      }

      label.sidebar-label {
        color: inherit;

        &:dir(ltr) { padding-right: 2px; }
        &:dir(rtl) { padding-left: 2px; }
      }

      button.sidebar-button {
        @extend %button-flat-simple;
        @extend %small-button;
      }

      &.sidebar-placeholder-row { background-color: $overlay-hover; }

      &.sidebar-new-bookmark-row {
        color: $primary;

        image.sidebar-icon { color: $primary; }
      }

      &:drop(active) {
        transition: $transition,
                    box-shadow 0ms;
        box-shadow: inset 0 0 0 9999px $overlay-hover;
      }
    }
  }
}

placesview {
  .server-list-button > image {
    transition: 200ms $ease-out;
    -gtk-icon-transform: rotate(0turn);
  }

  .server-list-button:checked > image {
    transition: 200ms $ease-out;
    -gtk-icon-transform: rotate(-0.5turn);
  }

  // this selects the "connect to server" label
  > actionbar > revealer > box > label {
    border-spacing: $space-size;
  }
}


/*********
 * Paned *
 *********/
paned {
  > separator {
    min-width: 1px;
    min-height: 1px;
    -gtk-icon-source: none; // defeats the ugly default handle decoration
    border-style: none; // just to be sure
    background-color: transparent;
    // workaround, using background istead of a border since the border will get rendered twice (?)
    background-image: image($divider);
    background-size: 1px 1px;
    background-clip: content-box; // avoids borders image being rendered twice (?)
    box-shadow: none;

    &.wide {
      min-width: 6px;
      min-height: 6px;
      background-color: $background;
      background-image: image($divider), image($divider);
      background-size: 1px 1px, 1px 1px;
    }
  }

  &.horizontal > separator {
    background-repeat: repeat-y;

    &:dir(ltr) {
      margin: 0 -8px 0 0;
      padding: 0 8px 0 0;
      background-position: left;
    }

    &:dir(rtl) {
      margin: 0 0 0 -8px;
      padding: 0 0 0 8px;
      background-position: right;
    }

    &.wide {
      margin: 0;
      padding: 0;
      background-repeat: repeat-y, repeat-y;
      background-position: left, right;
    }
  }

  &.vertical > separator {
    margin: 0 0 -8px 0;
    padding: 0 0 8px 0;
    background-repeat: repeat-x;
    background-position: top;

    &.wide {
      margin: 0;
      padding: 0;
      background-repeat: repeat-x, repeat-x;
      background-position: bottom, top;
    }
  }
}


/************
 * GtkVideo *
 ************/

video {
  & image.osd {
    min-width: 64px;
    min-height: 64px;
    border-radius: $circular-radius;
    border: none;
  }

  background: black;
  border-radius: $corner-radius;
}

/**************
 * GtkInfoBar *
 **************/
infobar {
  border: none;
  margin-bottom: 0;

  > revealer > box {
    padding: $space-size;
    border-spacing: $space-size * 2;
  }

  &.info {
    & > revealer > box,
    &:hover > revealer > box,
    &:backdrop > revealer > box {
      color: $text;
      background-color: $base;

      button {
        &, &.text-button:not(:disabled) { color: $primary; }
      }
    }
  }

  &.action,
  &.question {
    & > revealer > box,
    &:backdrop > revealer > box {
      background-color: $primary;
      color: on($primary);

      button {
        &, &:hover, &:focus, &:active, &:checked, &.text-button:not(:disabled) { color: on($primary); }
      }

      *:link { color: on($primary); }
    }

    &:hover > revealer > box {
      background-color: if($variant == 'light', lighten($primary, 5%), darken($primary, 5%));
    }
  }

  &.warning {
    & > revealer > box,
    &:backdrop > revealer > box {
      background-color: $warning;
      color: on($warning);

      button {
        @extend %button-on-dark;

        &, &:hover, &:focus, &:active, &:checked, &.text-button:not(:disabled) { color: on($warning); }
      }

      *:link { color: on($warning); }
    }

    &:hover > revealer > box {
      background-color: if($variant == 'light', lighten($warning, 5%), darken($warning, 5%));
    }
  }

  &.error {
    & > revealer > box,
    &:backdrop > revealer > box {
      background-color: $error;
      color: on($error);

      button {
        &, &:hover, &:focus, &:active, &:checked, &.text-button:not(:disabled) { color: on($error); }
      }

      *:link { color: on($error); }
    }

    &:hover > revealer > box {
      background-color: if($variant == 'light', lighten($error, 5%), darken($error, 5%));
    }
  }
}


/************
 * Tooltips *
 ************/
tooltip {
  &.background, &.background.csd {
    // background-color needs to be set this way otherwise it gets drawn twice
    // see https://bugzilla.gnome.org/show_bug.cgi?id=736155 for details.
    background-color: $tooltip;
    color: on($tooltip);
    box-shadow: $shadow-z4;
    border-radius: $corner-radius / 2;
    margin: 2px 6px 8px 6px;
    border: none;
  }

  padding: $space-size $space-size * 2;
  box-shadow: none; // otherwise it gets inherited by windowframe.csd

  > box {
    border-spacing: $space-size;
  }
}


/*****************
 * Color Chooser *
 *****************/
colorswatch {
  // This widget is made of two boxes one on top of the other, the lower box is colorswatch {} the other one
  // is colorswatch overlay {}, colorswatch has the programmatically set background, so most of the style is
  // applied to the overlay box.

  // base color corners rounding
  // to avoid the artifacts caused by rounded corner anti-aliasing the base color
  // sports a bigger radius.
  // nth-child is needed by the custom color strip.

  &.top {
    border-top-left-radius: $menu-radius;
    border-top-right-radius: $menu-radius;

    overlay {
      border-top-left-radius: $menu-radius;
      border-top-right-radius: $menu-radius;
    }
  }

  &.bottom {
    border-bottom-left-radius: $menu-radius;
    border-bottom-right-radius: $menu-radius;

    overlay {
      border-bottom-left-radius: $menu-radius;
      border-bottom-right-radius: $menu-radius;
    }
  }

  &.left,
  &:first-child:not(.top) {
    border-top-left-radius: $menu-radius;
    border-bottom-left-radius: $menu-radius;

    overlay {
      border-top-left-radius: $menu-radius;
      border-bottom-left-radius: $menu-radius;
    }
  }

  &.right,
  &:last-child:not(.bottom) {
    border-top-right-radius: $menu-radius;
    border-bottom-right-radius: $menu-radius;

    overlay {
      border-top-right-radius: $menu-radius;
      border-bottom-right-radius: $menu-radius;
    }
  }

  &.dark { color: on(dark); }

  &.light { color: on(light); }

  &#add-color-button {
    border-radius: $menu-radius $menu-radius 0 0;
    color: $text;

    &:only-child { border-radius: $menu-radius; }

    overlay {
      background-color: $surface;
    }
  }

  &:disabled {
    opacity: 0.5;

    overlay { box-shadow: none; }
  }

  &#editor-color-sample {
    border-radius: $menu-radius;

    overlay { border-radius: $menu-radius; }
  }
}

// colorscale popup
colorchooser .popover.osd {
  transition: $transition-shadow;
  border-radius: $corner-radius;
  box-shadow: $shadow-z4, inset 0 1px highlight($surface);
  background-color: $surface;

  &:backdrop { box-shadow: $shadow-z2, inset 0 1px highlight($surface); }
}


/********
 * Misc *
 ********/
// content view (grid/list)
.content-view {
  background-color: $background;

  // &:hover { -gtk-icon-effect: highlight; }

  rubberband, .rubberband { @extend rubberband; }
}

.scale-popup {
  // .osd & { @extend %osd; }

  // .osd & button.flat { // FIXME: quick hack, redo properly
  // }
  //
  // button { // +/- buttons on GtkVolumeButton popup
  // }
}


/**********************
 * Window Decorations *
 **********************/
window {
  outline: none;
  transition: $transition-shadow;
  border-radius: $window-radius;
  box-shadow: $shadow-z16, 0 16px (24px * .6) 2px transparent, 0 6px (30px * .6) 5px transparent;

  @if $variant == 'light' and $topbar == 'dark' {
    &.background {
      background-color: transparent;
      background-image: linear-gradient(to bottom,
                                        $titlebar,
                                        $titlebar $large-size,
                                        $background $large-size,
                                        $background);
    }
  }

  &:backdrop {
    // the transparent shadow here is to enforce that the shadow extents don't
    // change when we go to backdrop, to prevent jumping windows.
    // The biggest shadow should be in the same order then in the active state
    // or the jumping will happen during the transition.
    box-shadow: $shadow-z4, 0 16px (24px * .6) 2px transparent, 0 6px (30px * .6) 5px transparent;
  }

  &.popup {
    border-radius: $menu-radius;
    box-shadow: $shadow-z4;
  }

  &.dialog.message {
    border-radius: $window-radius;
  }

  .solid-csd & {
    margin: 0;
    padding: 2px;
    border-radius: 0;
    box-shadow: none;
    background-color: $titlebar;

    &:backdrop { background-color: $titlebar-backdrop; }
  }

  &.maximized,
  &.fullscreen,
  &.tiled,
  &.tiled-top,
  &.tiled-right,
  &.tiled-bottom,
  &.tiled-left { border-radius: 0; }
}

// Window button
windowcontrols {
  border-spacing: $space-size;

  &:not(.empty) {
    &.start:dir(ltr),
    &.end:dir(rtl) {
      margin-right: $space-size;
    }

    &.start:dir(rtl),
    &.end:dir(ltr) {
      margin-left: $space-size;
    }
  }

  button {
    @extend %circular-button;

    image {
      background-color: transparent;
      padding: 0;
    }
  }
}


// catch all extend :)

%selected_items {
  background-color: $overlay-selected;
}

%selected_items_color {
  color: $primary;
  background-color: rgba($primary, 0.2);
}

%selected_items_primary {
  color: on($primary);
  background-color: $primary;
}

.monospace { font-family: monospace; }

.numeric {
  font-feature-settings: "tnum";
}

/**********************
 * Touch Copy & Paste *
 **********************/
// touch selection handlebars for the Popover.osd above
cursor-handle {
  color: $primary;
  -gtk-icon-source: -gtk-recolor(url("assets/scalable/cursor-handle-symbolic.svg"));

  &.insertion-cursor:dir(ltr), &.insertion-cursor:dir(rtl) {
    padding-top: 6px;
  }
}

// shortcut window keys
shortcuts-section {
  margin: 20px;
}

.shortcuts-search-results {
  margin: 20px;
  border-spacing: 24px;
}

shortcut {
  border-spacing: 6px;
}

shortcut > .keycap {
  min-width: 28px - 8px * 2;
  min-height: 28px - 2px;
  margin-top: 2px;
  padding-bottom: 2px;
  padding-left: 8px;
  padding-right: 8px;
  border: solid 1px $divider;
  border-radius: 8px;
  box-shadow: inset 0 -2px $divider;
  background-color: $surface;
  background-clip: border-box;
  color: $text;
  font-size: smaller;
}

:not(decoration):not(window):drop(active) { // FIXME needs to be done widget by widget, this wildcard should really die
  caret-color: $primary;
}

stackswitcher {
  min-height: 0;
  padding: 0;
  // margin: $space-size 0;
  border-radius: $circular-radius;
  background-color: $overlay-normal;

  &.linked:not(.vertical) > button:not(.suggested-action):not(.destructive-action) {
    margin: 0 0;
    border-radius: $circular-radius;
    background-color: transparent;

    &.text-button { min-width: 100px; }

    &:focus { box-shadow: inset 0 0 0 2px $overlay-focus; }

    &:active {
      box-shadow: inset 0 0 0 9999px gtkalpha($primary, 0.08);
    }

    &:checked {
      background-color: $primary;
      color: on($primary);
    }
  }

  button.text-button { min-width: 100px; } // FIXME aggregate with buttons

  &.circular {
    border-spacing: $space-size * 2;

    button.circular,
    button.text-button.circular { // FIXME aggregate with buttons
      min-width: $medium-size;
      min-height: $medium-size;
      padding: 0;
    }
  }
}


/*************
 * App Icons *
 *************/
// Outline for low res icons
.lowres-icon {
  -gtk-icon-shadow: none;
}

// Drapshadow for large icons
.icon-dropshadow {
  -gtk-icon-shadow: none;
}


/*********
 * Emoji *
 *********/
popover.emoji-picker {
  padding: 0;

  > contents {
    padding: 0;
  }
}

.emoji-searchbar {
  padding: $space-size;
  border-spacing: $space-size;
  border-bottom: 1px solid $divider;
  background: none;

  entry {
    margin: 0;

    text {
      background: none;
      box-shadow: none;
    }
  }
}

.emoji-toolbar {
  padding: 0;
  border-spacing: $space-size / 2;
  border-top: 1px solid $divider;
  background: none;
  box-shadow: none;
}

button.emoji-section {
  margin: 0;
  padding: $space-size;
  border-radius: $corner-radius -$space-size / 2;

  &:checked {
    color: $primary;
  }
}

popover.emoji-picker emoji {
  font-size: x-large;
  padding: $space-size;
  transition: $transition;
  border-radius: $corner-radius;

  &:focus,
  &:hover {
    background: $overlay-hover;
  }
}

emoji-completion-row {
  min-height: $menuitem-size;
  padding: 0 $space-size * 2;

  > box {
    border-spacing: $space-size;
    padding: 2px $space-size;
  }

  &:focus, &:hover,
  emoji:hover, emoji:focus {
    background-color: $overlay-hover;
    color: $text;
  }
}

popover.entry-completion > contents {
  padding: 0;
}
